//+------------------------------------------------------------------+
//|                                                     AO multy.mq4 |
//|                         Copyright  2007, Vorobev Software Corp. |
//|                                               ovorobev@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Vorobev Software Corp."
#property link      "ovorobev@gmail.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 FireBrick
#property indicator_color3 Green
#property indicator_color4 DarkGreen
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
//---- input parameters
extern string Pairs = "GBPUSD";

double buf0[], buf1[], buf2[], buf3[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(0,buf0);
   SetIndexBuffer(1,buf1);
   SetIndexBuffer(2,buf2);
   SetIndexBuffer(3,buf3);
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   int limit;
   int counted_bars = IndicatorCounted();
   if(counted_bars>0) counted_bars--;
   limit = Bars - counted_bars;
   int i, j;
   double kk, kk1;
   kk1 = 0.00;
   for(i = limit; i > -1; i--) {
      kk = 0.0;
      kk = kk + iAO(Pairs, 0, i);
      if (kk > 0) {
         if (kk > kk1) {
            buf0[i] = 0;
            buf1[i] = 0;
            buf2[i] = kk;
            buf3[i] = 0;
         } else {
            buf0[i] = 0;
            buf1[i] = 0;
            buf2[i] = 0;
            buf3[i] = kk;
         }
      } else {
         if (kk < kk1) {
            buf0[i] = kk;
            buf1[i] = 0;
            buf2[i] = 0;
            buf3[i] = 0;
         } else {
            buf0[i] = 0;
            buf1[i] = kk;
            buf2[i] = 0;
            buf3[i] = 0;
         }
      }
      kk1 = kk;
   }
   return(0);
}
//+------------------------------------------------------------------+